// clang-format off
#include "score_addon_gbap.hpp"

#include <score/application/ApplicationContext.hpp>
#include <score/plugins/Interface.hpp>
#include <score/plugins/qt_interfaces/FactoryInterface_QtInterface.hpp>
#include <score/plugins/qt_interfaces/PluginRequirements_QtInterface.hpp>

#include <score_plugin_engine.hpp>
#include <score/plugins/FactorySetup.hpp>

#include <Avnd/Factories.hpp>

namespace spat { struct GBAP; } 


namespace spat { struct matrix; } 


namespace spat { struct MultiCursorManager; } 


namespace spat { struct PathGenerator; } 



score_addon_gbap::score_addon_gbap() = default;
score_addon_gbap::~score_addon_gbap() = default;

std::vector<score::InterfaceBase*> score_addon_gbap::factories(
        const score::ApplicationContext& ctx,
        const score::InterfaceKey& key) const
{
  std::vector<score::InterfaceBase*> fx;

  
::oscr::custom_factories<spat::GBAP>(fx, ctx, key); 


::oscr::custom_factories<spat::matrix>(fx, ctx, key); 


::oscr::custom_factories<spat::MultiCursorManager>(fx, ctx, key); 


::oscr::custom_factories<spat::PathGenerator>(fx, ctx, key); 



  return fx;
}

std::vector<score::PluginKey> score_addon_gbap::required() const
{
  return {score_plugin_engine::static_key()};
}

#include <score/plugins/PluginInstances.hpp>
SCORE_EXPORT_PLUGIN(score_addon_gbap)
