// clang-format off
#include "score_addon_onnx_models.hpp"

#include <score/application/ApplicationContext.hpp>
#include <score/plugins/Interface.hpp>
#include <score/plugins/qt_interfaces/FactoryInterface_QtInterface.hpp>
#include <score/plugins/qt_interfaces/PluginRequirements_QtInterface.hpp>

#include <score_plugin_engine.hpp>
#include <score/plugins/FactorySetup.hpp>

#include <Avnd/Factories.hpp>

namespace OnnxModels { struct YOLO7BlobDetector; } 


namespace OnnxModels { struct YOLO8Segmentation; } 


namespace OnnxModels { struct ResnetDetector; } 


namespace OnnxModels { struct EmotionNetDetector; } 


namespace OnnxModels::Yolo { struct PoseDetector; } 


namespace OnnxModels { struct BlazePoseDetector; } 


namespace OnnxModels { struct DepthAnythingV2; } 



score_addon_onnx_models::score_addon_onnx_models() = default;
score_addon_onnx_models::~score_addon_onnx_models() = default;

std::vector<score::InterfaceBase*> score_addon_onnx_models::factories(
        const score::ApplicationContext& ctx,
        const score::InterfaceKey& key) const
{
  std::vector<score::InterfaceBase*> fx;

  
::oscr::custom_factories<OnnxModels::YOLO7BlobDetector>(fx, ctx, key); 


::oscr::custom_factories<OnnxModels::YOLO8Segmentation>(fx, ctx, key); 


::oscr::custom_factories<OnnxModels::ResnetDetector>(fx, ctx, key); 


::oscr::custom_factories<OnnxModels::EmotionNetDetector>(fx, ctx, key); 


::oscr::custom_factories<OnnxModels::Yolo::PoseDetector>(fx, ctx, key); 


::oscr::custom_factories<OnnxModels::BlazePoseDetector>(fx, ctx, key); 


::oscr::custom_factories<OnnxModels::DepthAnythingV2>(fx, ctx, key); 



  return fx;
}

std::vector<score::PluginKey> score_addon_onnx_models::required() const
{
  return {score_plugin_engine::static_key()};
}

#include <score/plugins/PluginInstances.hpp>
SCORE_EXPORT_PLUGIN(score_addon_onnx_models)
