/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright by The HDF Group.                                               *
 * All rights reserved.                                                      *
 *                                                                           *
 * This file is part of HDF5.  The full HDF5 copyright notice, including     *
 * terms governing use, modification, and redistribution, is contained in    *
 * the COPYING file, which can be found at the root of the source code       *
 * distribution tree, or in https://www.hdfgroup.org/licenses.               *
 * If you do not have access to either file, you may request a copy from     *
 * help@hdfgroup.org.                                                        *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "H5private.h"

H5_GCC_DIAG_OFF("larger-than=")
H5_CLANG_DIAG_OFF("overlength-strings")

const char H5build_settings[]=
    "       SUMMARY OF THE HDF5 CONFIGURATION\n"
    "       =================================\n"
    "\n"
    "General Information:\n"
    "-------------------\n"
    "                   HDF5 Version: 1.14.5\n"
    "                  Configured on: 2025-07-07\n"
    "                  Configured by: Unix Makefiles\n"
    "                    Host system: Linux-6.14.9-300.fc42.x86_64\n"
    "              Uname information: Linux\n"
    "                       Byte sex: \n"
    "             Installation point: /usr\n"
    "\n"
    "Compiling Options:\n"
    "------------------\n"
    "                     Build Mode: RELEASE\n"
    "              Debugging Symbols: OFF\n"
    "                        Asserts: OFF\n"
    "                      Profiling: OFF\n"
    "             Optimization Level: OFF\n"
    "\n"
    "Linking Options:\n"
    "----------------\n"
    "                      Libraries: \n"
    "  Statically Linked Executables: OFF\n"
    "                        LDFLAGS: -fuse-ld=mold -Wl,-z,relro -Wl,--as-needed  -Wl,-z,pack-relative-relocs -Wl,-z,now --config=/usr/lib/rpm/redhat/redhat-hardened-clang-ld.cfg   -Wl,--build-id=sha1\n"
    "                     H5_LDFLAGS: \n"
    "                     AM_LDFLAGS: \n"
    "                Extra libraries: m;dl\n"
    "                       Archiver: /usr/bin/llvm-ar\n"
    "                       AR_FLAGS: \n"
    "                         Ranlib: /usr/bin/llvm-ranlib\n"
    "\n"
    "Languages:\n"
    "----------\n"
    "                              C: YES\n"
    "                     C Compiler: /usr/bin/clang 20.1.8\n"
    "                       CPPFLAGS: \n"
    "                    H5_CPPFLAGS: \n"
    "                    AM_CPPFLAGS: \n"
    "                        C Flags:  -std=c99 -O2  -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS --config=/usr/lib/rpm/redhat/redhat-hardened-clang.cfg -fstack-protector-strong   -m64 -march=x86-64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer\n"
    "                     H5 C Flags: -Wall;-Warray-bounds;-Wcast-qual;-Wconversion;-Wdouble-promotion;-Wextra;-Wformat=2;-Wframe-larger-than=16384;-Wimplicit-fallthrough;-Wnull-dereference;-Wunused-const-variable;-Wwrite-strings;-Wpedantic;-Wvolatile-register-var;-Wno-c++-compat;-Wbad-function-cast;-Wimplicit-function-declaration;-Wincompatible-pointer-types;-Wmissing-declarations;-Wpacked;-Wshadow;-Wswitch;-Wno-error=incompatible-pointer-types-discards-qualifiers;-Wunused-function;-Wunused-variable;-Wunused-parameter;-Wcast-align;-Wformat;-Wno-missing-noreturn\n"
    "                     AM C Flags: \n"
    "               Shared C Library: NO\n"
    "               Static C Library: YES\n"
    "\n"
    "\n"
    "                        Fortran: \n"
    "               Fortran Compiler:  \n"
    "                  Fortran Flags: \n"
    "               H5 Fortran Flags: \n"
    "               AM Fortran Flags: \n"
    "         Shared Fortran Library: NO\n"
    "         Static Fortran Library: YES\n"
    "               Module Directory: \n"
    "\n"
    "                            C++: \n"
    "                   C++ Compiler: /usr/bin/clang++ 20.1.8\n"
    "                      C++ Flags: -O2 -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3  --config=/usr/lib/rpm/redhat/redhat-hardened-clang.cfg -fstack-protector-strong -m64 -march=x86-64 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer\n"
    "                   H5 C++ Flags: \n"
    "                   AM C++ Flags: \n"
    "             Shared C++ Library: NO\n"
    "             Static C++ Library: YES\n"
    "\n"
    "                           Java: \n"
    "                  Java Compiler:  \n"
    "\n"
    "\n"
    "Features:\n"
    "---------\n"
    "                     Parallel HDF5: 0\n"
    "  Parallel Filtered Dataset Writes: \n"
    "                Large Parallel I/O: \n"
    "                High-level library: NO\n"
    "Dimension scales w/ new references: \n"
    "                  Build HDF5 Tests: 0\n"
    "                  Build HDF5 Tools: 0\n"
    "                   Build GIF Tools: \n"
    "                      Threadsafety: 1\n"
    "               Default API mapping: v114\n"
    "    With deprecated public symbols: ON\n"
    "            I/O filters (external):  DEFLATE\n"
    "                  _Float16 support: OFF\n"
    "                     Map (H5M) API: \n"
    "                        Direct VFD: \n"
    "                        Mirror VFD: \n"
    "                     Subfiling VFD: \n"
    "                (Read-Only) S3 VFD: \n"
    "              (Read-Only) HDFS VFD: \n"
    "    Packages w/ extra debug output: \n"
    "                       API tracing: OFF\n"
    "              Using memory checker: OFF\n"
    "                  Use file locking: best-effort\n"
    "         Strict file format checks: OFF\n"
    "      Optimization instrumentation: \n"
;

H5_GCC_DIAG_ON("larger-than=")
H5_CLANG_DIAG_OFF("overlength-strings")
